
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>

#define _(p) p

static FILE *sock_in, *sock_out;

static void default_shohei_error(char *p)
{
        fprintf(stderr, "%s\n", p);
        exit(EXIT_FAILURE);
}
 
void (*shohei_error)(char *) = default_shohei_error;


/* This isn't right. I should open several sockets and run select
   on all of them to get some parallelism. This will be too slow.
*/

void open_socket(char *host, int portnum)
{
        struct sockaddr_in sa;
        struct hostent *hp;
        int s;
 
        hp = gethostbyname(host);
        if (hp == NULL) hp = gethostbyname(host);
        if (hp == NULL) {
                fprintf(stderr, "Host = '%s', h_error = %d\n", host, h_errno);
                (*shohei_error)(_("gethostbyname returns NULL"));
        }
        memset(&sa, '\0', sizeof sa);
        bcopy(hp->h_addr, (char *)&sa.sin_addr, hp->h_length);
        sa.sin_family = hp->h_addrtype;
        sa.sin_port = htons(portnum);
        s = socket(hp->h_addrtype, SOCK_STREAM, 0);
        if (s < 0)
                (*shohei_error)(_("socket() failed"));
        if (connect(s, (struct sockaddr *)&sa, sizeof sa) < 0)
                (*shohei_error)(_("connect() failed"));
        sock_out = fdopen(s, "w");
        sock_in = fdopen(dup(s), "r");
        if (sock_out == NULL || sock_in == NULL)
                (*shohei_error)(_("Can't fdopen socket"));
}
 
void close_socket(void)
{
        if (sock_in) {
                fclose(sock_in);
                sock_in = NULL;
        }
        if (sock_out) {
                fclose(sock_out);
                sock_out = NULL;
        }
}

char *http_get(char *host, int port, char *uri)
{
	char b[1024];
	FILE *fp = fopen("cache", "w");

	open_socket(host, port);
	fprintf(sock_out, "GET %s HTTP/1.0\r\n\r\n", uri);
	fflush(sock_out);

	while (fgets(b, sizeof b, sock_in)) {
		fprintf(fp, "%s", b);
	}
	fclose(fp);
	close_socket();	
	return "cache";
}

int parse_url(char *url, char *proto, char *host, int *port, char *uri)
{
	char b[1024];
	int n;

	n = sscanf(url, "%[^:]://%[^/]%s", proto, b, uri);
 
        if (n == 2 || uri[0] != '/') {
                strcpy(uri, "/");
                n++;
        }
	if (n != 3) return 1;

	n = sscanf(b, "%[^:]:%d", host, port);
	if (n != 2) *port = 80;

	return 0;
}

